package com.fuzamei.service;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.fuzamei.dao.OperationHistoryDao;
import com.fuzamei.dao.UserAuthoricationDao;
import com.fuzamei.entity.OperationHistory;
import com.fuzamei.entity.OperationHistoryBO;
import com.fuzamei.entity.UserDetail;
import com.fuzamei.utils.DateUtil;
import com.fuzamei.utils.PageDTO;
import com.fuzamei.utils.StringUtil;

@Service
public class OperationHistoryService {

	@Autowired
	private OperationHistoryDao operationHistoryDao;

	@Autowired
	private UserAuthoricationDao userAuthoricationDao;

	/**
	 * 
	* @Title: queryOperationHistoryInformation
	* @Description: TODO(根据用户的id号查询操作记录，但是现在只做了风管岗可以查看所有的信息，)
	* @param @param map
	* @param @return    设定文件
	* @return PageDTO    返回类型
	* @author ylx
	* @date 2017年12月27日 下午3:02:42
	* @throws
	 */
	public PageDTO queryOperationHistoryInformation(Map<String, Object> map) {
		PageDTO pageDto = new PageDTO(); // 创建分页对象
		//定义一个查询信息的list
		List<OperationHistory> informationList=null;
		int userId = (Integer) map.get("userId");
		UserDetail userDetail=userAuthoricationDao.queryUserDetailInformation(userId);
		if(userDetail==null){
			throw new RuntimeException("用户信息不存在");
		}
		List<String> roleList = userDetail.getRole_name();
		if(roleList.contains("风管岗")){
			// 去dao层取分页的数据,因为是风管岗位，可以查看所有人的操作记录
			informationList = operationHistoryDao.queryOperationHistoryInformation(map); 
		}else{
			//根据用户id号查询出用户的账号account信息
			//TODO这里还有上下级关系查看的问题还没解决============================================================>>>>>>待定
			String account = userDetail.getAccount();
			if(StringUtil.isEmpty(account)){
				throw new RuntimeException("用户账号信息不存在");
			}
			map.put("Account", account);
			informationList = operationHistoryDao.queryOperationHistoryInformationByUser(map); 
		}
		int count = operationHistoryDao.findAllInformation();
		pageDto.setTotal(count);
		pageDto.setRows(informationList);
		return pageDto;
	}

	

	/**
	 * 
	* @Title: queryOperationHistoryInformation
	* @Description: TODO(controller层通过对象的形式传入信息查询)
	* @param @param operationHistoryBO
	* @param @return    设定文件
	* @return PageDTO    返回类型
	* @author ylx
	* @date 2017年12月26日 下午4:26:44
	* @throws
	 */
	/*public PageDTO queryOperationHistoryInformation(OperationHistoryBO operationHistoryBO) {
		Integer userId = operationHistoryBO.getUserId();
		Integer page = operationHistoryBO.getPage();
		String account = operationHistoryBO.getAccount();
		String role = operationHistoryBO.getRole(); // 操作角色默认空值
		String type = operationHistoryBO.getType(); // 操作类型默认空值
		Long startTime = operationHistoryBO.getStartTime(); // 开始时间默认0
		Long endTime = operationHistoryBO.getEndTime(); // 结束时间
		PageDTO pageDto = new PageDTO(); // 创建分页对象
		Map<String, Object> mapToDao = new LinkedHashMap<String, Object>();
		mapToDao.put("startPage", (page - 1) * ROW_NUM);
		mapToDao.put("account", account);
		mapToDao.put("role", role);
		mapToDao.put("type", type);
		mapToDao.put("startTime", startTime);
		mapToDao.put("endTime", endTime);
		mapToDao.put("rowNum", ROW_NUM); //默认每页显示数据是10条，可根据需求修改分页数量
		List<OperationHistory> informationList = operationHistoryDao.queryOperationHistoryInformation(mapToDao); //去dao层取分页的数据
		int count = operationHistoryDao.findAllInformation();	//查询总信息条数
		pageDto.setTotal(count);
		pageDto.setRows(informationList);
		return pageDto;
	}*/
	
	/*//定义一个查询信息的list
	List<OperationHistory> informationList=null;
	int userId = (Integer) map.get("userId");
	//查询用户的角色信息
	List<String> roleList = userAuthoricationDao.queryUserRoleNames(userId);
	//如果没有角色信息直接抛出异常信息
	if(roleList==null||roleList.size()==0){
		throw new RuntimeException("用户角色信息不存在");
	}
	if(roleList.contains("风管岗")){
		// 去dao层取分页的数据,因为是风管岗位，可以查看所有人的操作记录
		informationList = operationHistoryDao.queryOperationHistoryInformation(map); 
	}else{
		//根据用户id号查询出用户的账号account信息
		String account = userAuthoricationDao.queryUserAccount(userId);
		if(StringUtil.isEmpty(account)){
			throw new RuntimeException("用户信息不存在");
		}
		map.put("Account", account);
		informationList = operationHistoryDao.queryOperationHistoryInformationByUser(map); 
	}*/

}
